<?php
class WatuPROGetBridge {
   static function main() {
   	  global $wpdb;
   	  
   	  // save GetResponse API key and API endpoint
   	  if(!empty($_POST['set_key']) and check_admin_referer('watuproget_settings')) {
			  $double_optin = empty($_POST['no_optin']) ? 0 : 1;   	 
			  $is_360 = empty($_POST['is_360']) ? 0 : 1; 	
			  $type = sanitize_text_field($_POST['type']);
			  $domain = sanitize_text_field($_POST['domain']);
   	  	
   	  	  update_option('watuproget_api_key', sanitize_text_field($_POST['api_key']));
   	  	  update_option('watuproget_is_360', $is_360);
   	  	  update_option('watuproget_type', $type);
   	  	  update_option('watuproget_domain', $domain);
     	  }
   	  
   	  $api_key = get_option('watuproget_api_key');
   	  $is_360 = get_option('watuproget_is_360');
   	  $type = get_option('watuproget_type');
   	  if(!preg_match('/^https/', $type)) $type = 'https://'.$type;
   	  $domain = get_option('watuproget_domain');
   	 
   	  // select exams
   	  $exams = $wpdb->get_results("SELECT * FROM ".WATUPRO_EXAMS." ORDER BY name");
   	  
   	
   	  // add/edit/delete relation
   	  if(!empty($_POST['add']) and check_admin_referer('watuproget_rule')) {
				// no duplicates		
				$exists = $wpdb->get_var($wpdb->prepare("SELECT id FROM ".WATUPROGET_RELATIONS."
					WHERE exam_id=%d AND campaign_id=%s AND grade_id=%d", $_POST['exam_id'], $_POST['campaign_id'], $_POST['grade_id']));   	  	
   	  	
   	  	if(!$exists) {
					$wpdb->query($wpdb->prepare("INSERT INTO ".WATUPROGET_RELATIONS." SET 
						exam_id = %d, campaign_id=%s, grade_id=%d", $_POST['exam_id'], $_POST['campaign_id'], $_POST['grade_id']));
					}   	  
   	  }
   
   		if(!empty($_POST['save']) and check_admin_referer('watuproget_rule')) {
				$wpdb->query($wpdb->prepare("UPDATE ".WATUPROGET_RELATIONS." SET 
					exam_id = %d, campaign_id=%s, grade_id=%d WHERE id=%d", 
					$_POST['exam_id'], $_POST['campaign_id'], $_POST['grade_id'], $_POST['id']));   	  
   	  }
   	  
			if(!empty($_POST['del']) and check_admin_referer('watuproget_rule')) {
				$wpdb->query($wpdb->prepare("DELETE FROM ".WATUPROGET_RELATIONS." WHERE id=%d", $_POST['id']));
			}   	  
   	  
   	  // select existing relations
   	  $relations = $wpdb->get_results("SELECT * FROM ".WATUPROGET_RELATIONS." ORDER BY id");
   	  
   	  // select all non-category grades and match them to exams and relations
   	  $grades = $wpdb->get_results("SELECT * FROM ".WATUPRO_GRADES." WHERE cat_id=0 ORDER BY gtitle");
   	  
   	  foreach($exams as $cnt=>$exam) {
   	  	  $exam_grades = array();
   	  	  foreach($grades as $grade) {
   	  	  	if($grade->exam_id == $exam->ID) $exam_grades[] = $grade;
			  }
			  
			  $exams[$cnt]->grades = $exam_grades;
   	  }
   	  
   	  foreach($relations as $cnt=>$relation) {
   	  	  $rel_grades = array();
   	  	  foreach($grades as $grade) {
   	  	  	if($grade->exam_id == $relation->exam_id) $rel_grades[] = $grade;
			  }
			  
			  $relations[$cnt]->grades = $rel_grades;
   	  }
   	     	  
   	     	  
   	  // get campaigns
   	 // $ch = curl_init(); 
		  $headers = array('X-Auth-Token: api-key ' . $api_key,
			'Content-Type: application/json',
			'User-Agent: PHP GetResponse client 0 . 0 . 1',
			'X-APP-ID: 74a0976d-5d56-486a-9f1c-84081608932d'
		);
			
		  $url = self :: get_url();
		  $url .= "/campaigns";	
		  
		 /* $options = array(
			CURLOPT_URL => $url,
			CURLOPT_ENCODING => 'gzip,deflate',
			CURLOPT_FRESH_CONNECT => 1,
			CURLOPT_RETURNTRANSFER => 1,
			CURLOPT_TIMEOUT => 60,
			CURLOPT_HEADER => false,
			CURLOPT_HTTPHEADER => $headers
		);
		  
   	 $curl = curl_init();
		 curl_setopt_array($curl, $options);
		 $json_result = curl_exec($curl);
		 curl_close($curl);*/
		 
		  $headers = array('X-Auth-Token' => 'api-key ' . $api_key,
			'Content-Type' => 'application/json',
		);
		 if (!empty($domain)) {
				$headers[] = 'X-Domain: ' . $domain;
			}	
					
		
		 $json_result = wp_remote_request($url, array(			   
			    'headers'     => $headers
		    ));		
		  //  print_r($json_result);
			if( is_wp_error( $json_result  ) ) {
			    echo $json_result->get_error_message();
			    $json = '';
			}
			else $json = json_decode($json_result['body']);

		// print_r($json);   	     	  
		 include(WATUPROGET_PATH."/views/main.html.php");
   }

	 // actually subscribe the user
	 static function complete_exam($taking_id) {
	 	  global $wpdb;
		 
	 	  // select taking		
	 	  $taking = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_TAKEN_EXAMS." 	
	 	  	WHERE ID=%d", $taking_id));
	 	  	
	 	  // if email not available, return false
			if(empty($taking->user_id) and empty($taking->email)) return false;
			
	 	  // see if there are any relations for this exam ID
	 	  $relations = $wpdb->get_results($wpdb->prepare("SELECT * FROM ".WATUPROGET_RELATIONS." 
		 	  WHERE exam_id=%d", $taking->exam_id));
		 	  
		 	if(!sizeof($relations)) return false;  
		 	 // echo "HERE BRIDGE 2";
	
			$email = $taking->email;
			$name = $taking->name;
			if(empty($email)) {
				$user = get_userdata($taking->user_id);
	      	$email = $user->user_email;
	      	$name = $user->display_name;
			}
			
			// name still empty? Default to guest although that's not a great idea
			if(empty($name)) $name = 'Guest';
	      
	      // add to GetResponse
	      $api_key = get_option('watuproget_api_key');   
   	   $domain = get_option('watuproget_domain');
	   	   	
	   	$double_optin = (get_option('watuproget_no_optin') == '1') ? false : true;
	   	
	   	// if the grade is cumulative we should actually replace $taking->grade_id with included_grade_ids and compare as text
	   	// so relations including any grade are accepted
	   	if(!empty($taking->grade_id)) {
	   		$grade = $wpdb->get_row($wpdb->prepare("SELECT is_cumulative_grade, included_grade_ids FROM ".WATUPRO_GRADES." WHERE ID=%d", $taking->grade_id));
	   	}
	   	
	   	// select mailing lists from getresponse
	   	foreach($relations as $relation) {
			  // check grade
			  if(empty($grade->is_cumulative_grade) and !empty($relation->grade_id) and $relation->grade_id != $taking->grade_id) continue;
			  if(!empty($grade->is_cumulative_grade) and !empty($relation->grade_id) and !strstr($grade->included_grade_ids, '|'.$relation->grade_id.'|')) continue;
			  
			  $json = '{
				   "name": "'.$name.'",
    				"email": "'.$email.'",	
    				"dayOfCycle": "0",
    				"campaign": {
				        "campaignId": "'.$relation->campaign_id.'"
				    },
				    "ipAddress": "'.$_SERVER['REMOTE_ADDR'].'"
		  
			  }';
			  //echo $json;
			 
 
			  $headers = array('X-Auth-Token' => 'api-key ' . $api_key,
			'Content-Type' => 'application/json',
		);
		 if (!empty($domain)) {
				$headers[] = 'X-Domain: ' . $domain;
			}	
			
			  $url = self :: get_url();
			  $url .= "/contacts";	
			  
			 /* $options = array(
				CURLOPT_URL => $url,
				CURLOPT_ENCODING => 'gzip,deflate',
				CURLOPT_FRESH_CONNECT => 1,
				CURLOPT_RETURNTRANSFER => 1,
				CURLOPT_TIMEOUT => 60,
				CURLOPT_HEADER => false,
				CURLOPT_HTTPHEADER => $headers,
				CURLOPT_POST => 1,
				CURLOPT_CUSTOMREQUEST => 'POST',
				CURLOPT_POSTFIELDS => $json
			);
			  
	   	 $curl = curl_init();
			 curl_setopt_array($curl, $options);
			 $json_result = curl_exec($curl);
			 if (false === $curlExec) {
            // echo "Could not do the CURL request.";
          }
			 // print_r($json_result);
			 curl_close($curl);	 */
			 
			 	$json_result = wp_remote_post($url, array(
			    'method'      => 'POST',
			    'timeout'     => 45,
			    'headers'     => $headers,
			    'body'        => $json,
			    'cookies'     => array()
		    ));		
		    ///	print_r($json_result);
			if( is_wp_error( $json_result  ) ) {
			    echo $json_result->get_error_message();
			    $result = '';
			}
			else $result = json_decode($json_result['body']);
			//echo "GETRESPONSE RESULT:";
			//print_r($json_result);
				
			} // end foreach relation	
   } // end complete exam
   
   // get API endpoint URL based on settings
   static function get_url() {
   	 $is_360 = get_option('watuproget_is_360');
  	 
   	 if(!$is_360) return 'https://api.getresponse.com/v3';
   	 
   	 // else 
   	 $type = get_option('watuproget_type');
   	 if(!preg_match('/^https/', $type)) $type = 'https://'.$type;
   	 return $type; 
   }
}