<div class="wrap">
	<h1><?php _e('WatuPRO to GetResponse Bridge', 'watuproget')?></h1>
	
	<p><?php _e('This bridge lets you automatically subscribe users who take your exams into select list in GetResponse.', 'watuproget')?></p>
	
	<?php if ( ! extension_loaded('curl') or ! is_callable('curl_init')):?>
		<p class="error">You will not be able to use this bridge because PHP curl extension is not installed on your server. Please contact your server admin or hosting support about this. Do not send email to us.</p>
	<?php endif;?>
	
	<p><?php _e('Note that in order to have quiz taker subscribed you need their email address. So this will work the user is logged or (for non-logged in users) when you have selected "Send email to the user with their results" in the exam settings page.','watuproget')?> </p>
	
	<form method="post" onsubmit="return validateGetForm(this);">
		<p>Your GetReponse API Key: <input type="text" name="api_key" value="<?php echo $api_key?>" size="60"> </p>
		
		<p><input type="checkbox" name="is_360" value="1" <?php if(!empty($is_360)) echo 'checked'?> onclick="this.checked ? jQuery('#is360').show() : jQuery('#is360').hide();"> This is a GetResponse360 account</p>		
		
		<div id="is360" style='display:<?php echo $is_360 ? 'block' : 'none';?>'>
			<p>Type: <select name="type">
				<option value="api3.getresponse360.pl/v3" <?php if(strstr($type, 'api3.getresponse360.pl/v3')) echo 'selected';?>>GetResponse 360 PL</option>
				<option value="api3.getresponse360.com/v3" <?php if(strstr($type, 'api3.getresponse360.com/v3')) echo 'selected';?>>GetResponse 360 COM</option>
			</select></p>
			<p>Domain: <input type="text" name="domain" value="<?php echo $domain?>"></p>
		</div>
		
		<input type="submit" name="set_key" value="<?php _e('Save Settings', 'watuproget');?>"</p>
		<?php wp_nonce_field('watuproget_settings');?>
	</form> 
	
	<?php if(empty($api_key)):?>
		<p><b><?php _e('You will not be able to add any rules until you enter your GetResponse API Key.', 'watuproget');?></b></p>
	<?php return;
	endif;
	if(!empty($json->code) or empty($json)):?>
		<p><?php _e("We couldn't retrieve any campaigns from your GetResponse account.", 'watuproget');?></p>
		<?php if(!empty($json->code)):?>
			<p><?php _e("We got this error:", 'watuproget');?> <b><?php echo $json->message;?></b></p>
		<?php endif;?>
		<p><a href="#" onclick="jQuery('#CmonResponse').toggle();return false;"><?php _e('Raw GetResponse response (debug)', 'watuproget');?></a></p>
		<div style="display:none;" id="CmonResponse"><?php echo $json_result;?></div>
	<?php endif;?>
   
   <h2><?php _e('Add New Rule', 'watuproget')?></h2>	  
	  
	 <form method="post" onsubmit="return validateRuleForm(this);">
	 	<div class="wrap">
	 			<?php _e('When user completes', 'watuproget')?> <select name="exam_id" onchange="wcChangeQuiz(this.value, 'wbbGradeSelector');">
	 				<option value=""><?php _e('Select quiz', 'watuproget');?></option>
	 			<?php foreach($exams as $exam):?>
	 				<option value="<?php echo $exam->ID?>"><?php echo stripslashes($exam->name)?></option>
	 			<?php endforeach;?>
	 			</select> 
				
				<?php _e('achieving the following grade:', 'watuproget')?>
				<span id="wbbGradeSelector">
					<select name="grade_id">
					   <option value="0"><?php _e('- Any grade -', 'watuproget');?></option>
					   <?php foreach($exams[0]->grades as $grade):?>
					   	<option value="<?php echo $grade->ID?>"><?php echo stripslashes($grade->gtitle);?></option>
					   <?php endforeach;?>
					</select>
				</span>				
				 			
	 			<?php printf(__('subscribe them to campaign','watuproget'), '');?> 
	 			<select name="campaign_id">
	 				<option value=""><?php _e('Select campaign', 'watuproget');?></option>
	 				<?php foreach($json as $campaign):?>
	 					<option value="<?php echo $campaign->campaignId?>"><?php echo $campaign->name?></option>
	 				<?php endforeach;?>
	 			</select>
	 			<input type="submit" name="add" value="<?php _e('Add Rule', 'watuproget')?>">
	 	</div>
	 	<?php wp_nonce_field('watuproget_rule');?>
	 </form> 
	 
	 <h2><?php _e('Manage Existing Rules', 'watuproget')?></h2>
	 <?php if(count($relations)):?>
	 	<?php foreach($relations as $relation):?>
	 	<form method="post">
	 	<input type="hidden" name="id" value="<?php echo $relation->id?>">
	 	<input type="hidden" name="del" value="0">
	 	<div class="wrap">
	 			<?php _e('When user completes', 'watuproget')?> <select name="exam_id" onchange="wcChangeQuiz(this.value, 'wbbGradeSelector<?php echo $relation->id?>');">
	 			<?php foreach($exams as $exam):
	 				$selected = ($exam->ID == $relation->exam_id) ? " selected" : "";?>
	 				<option value="<?php echo $exam->ID?>"<?php echo $selected?>><?php echo stripslashes($exam->name)?></option>
	 			<?php endforeach;?>
	 			</select> 
	 			
				<?php _e('achieving the following grade:', 'watuproget')?>
				<span id="wbbGradeSelector<?php echo $relation->id?>">
					<select name="grade_id">
					   <option value="0"><?php _e('- Any grade -', 'watuproget');?></option>
					   <?php foreach($relation->grades as $grade):
					   	$selected = ($grade->ID == $relation->grade_id) ? " selected" : "";?>
					   	<option value="<?php echo $grade->ID?>"<?php echo $selected?>><?php echo stripslashes($grade->gtitle);?></option>
					   <?php endforeach;?>
					</select>
				</span>			
					 			
	 			<?php _e('subscribe them to campaign','watuproget')?> 
	 			<select name="campaign_id">
	 				<?php foreach($json as $campaign):
	 					$selected = ($campaign->campaignId == $relation->campaign_id) ? 'selected' : '';?>
	 					<option value="<?php echo $campaign->campaignId?>" <?php echo $selected;?>><?php echo $campaign->name?></option>
	 				<?php endforeach;?>
	 			</select>
	 			<input type="submit" name="save" value="<?php _e('Save Rule', 'watuproget')?>">
	 			<input type="button" value="<?php _e('Delete Rule', 'watuproget')?>" onclick="WCConfirmDelete(this.form);">
	 	</div>
	 	<?php wp_nonce_field('watuproget_rule');?>
	 </form> 
	 	<?php endforeach;?>
	 <?php else: 
	 	echo "<p>".__('You have not created any rules yet.', 'watuproget')."</p>"; 
	 	endif;?>
</div>

<script type="text/javascript" >
function WCConfirmDelete(frm) {
		if(confirm("<?php _e('Are you sure?', 'wbbridge')?>")) {
			frm.del.value=1;
			frm.submit();
		}
}

function wcChangeQuiz(quizID, selectorID) {
	// array containing all grades by exams
	var grades = {<?php foreach($exams as $exam): echo $exam->ID.' : {';
			foreach($exam->grades as $grade):
				echo $grade->ID .' : "'.$grade->gtitle.'",';
			endforeach;
		echo '},';
	endforeach;?>};
	
	// construct the new HTML
	var newHTML = '<select name="grade_id">';
	newHTML += "<option value='0'><?php _e('- Any grade -', 'watuproget');?></option>";
	jQuery.each(grades, function(i, obj){
		if(i == quizID) {
			jQuery.each(obj, function(j, grade) {
				newHTML += "<option value=" + j + ">" + grade + "</option>\n";
			}); // end each grade
		}
	});
	newHTML += '</select>'; 
	
	jQuery('#'+selectorID).html(newHTML);
}

function validateRuleForm(frm) {
	if(frm.exam_id.value == '') {
		alert("<?php _e('Please select quiz', 'watuproget');?>");
		frm.exam_id.focus();
		return false;
	}
	
	if(frm.campaign_id.value == '') {
		alert("<?php _e('Please select campaign', 'watuproget');?>");
		frm.campaign_id.focus();
		return false;
	}
	
	return true;
}

function validateGetForm(frm) {
	if(frm.is_360.checked && frm.domain.value == '') {
		alert("<?php _e('You must enter the domain of your account.', 'watuproget');?>");
		frm.domain.focus();
		return false;
	}
	
	return true;
}
</script>